#ifndef __EditData_HeaderPlusPlus__
#define __EditData_HeaderPlusPlus__

#include <vector>

struct EditData
{
	typedef std::vector<String> files_t;
	files_t files;
	files_t::size_type sel;

	EditData() : sel(-1) {}
	EditData(LPEDATA edPtr) : sel(-1)
	{
		Deserialize(edPtr);
	}
	bool Deserialize(LPEDATA edPtr)
	{
		char *p = &edPtr->data;
		files_t::size_type size = *((files_t::size_type*)p);		p += sizeof(size);
		sel = *((files_t::size_type*)p);							p += sizeof(sel);
		for(files_t::size_type i = 0; i < size; ++i)
		{
			files.push_back(p);										PassNull(p);
		}

		return true;
	}
	bool Serialize(LPMV mV, LPEDATA &edPtr)
	{
		unsigned size = 0;
		size += sizeof(files_t::size_type);
		size += sizeof(sel);
		for(files_t::iterator it = files.begin(); it != files.end(); ++it)
		{
			size += (it->length()+1)*sizeof(Char);
		}

		LPEDATA t = (LPEDATA)mvReAllocEditData(mV, edPtr, sizeof(EDITDATA)+size);
		if(t) edPtr = t;
		else return false;

		char *p = &edPtr->data;
		files_t::size_type sz = files.size();
		memcpy(p, &sz, sizeof(sz));									p += sizeof(sz);
		memcpy(p, &sel, sizeof(sel));								p += sizeof(sel);
		for(files_t::iterator it = files.begin(); it != files.end(); ++it)
		{
			memcpy(p, it->c_str(), (it->length()+1)*sizeof(Char));	PassNull(p);
		}

		return true;
	}

	~EditData(){}
private:
	EditData(const EditData &);
	EditData &operator=(const EditData &);
#ifdef UNICODE
	static void PassNull(char *&p)
	{
		while(*(p++))++p;
	}
#else
	static void PassNull(char *&p)
	{
		while(*(p++));
	}
#endif
};

#endif