#include "Common.h"

#ifndef RUN_ONLY
namespace Prop
{
	enum
	{
		zzzunused = PROPID_EXTITEM_CUSTOM_FIRST,
		Files,
		File,
	};
}

FilenameCreateParam fcp = {"All Files (*)|*|", OFN_FILEMUSTEXIST};
#define MKRS (UINT_PTR)LPCSTR
PropData Properties[] =
{
	PropData_ComboBox(Prop::Files, MKRS("Files"), MKRS("The files already added"), 0),
	PropData_Filename(Prop::File, MKRS("File Selector"), MKRS("Use to select files"), &fcp),
	PropData_End()
};
#endif

BOOL WINAPI DLLExport GetProperties(LPMV mV, LPEDATA edPtr, BOOL bMasterItem)
{
#ifndef RUN_ONLY
	mvInsertProps(mV, edPtr, Properties, PROPID_TAB_GENERAL, TRUE);
#endif
	return TRUE;
}
void WINAPI DLLExport ReleaseProperties(LPMV mV, LPEDATA edPtr, BOOL bMasterItem)
{
#ifndef RUN_ONLY
#endif
}

char **Combo = 0;
unsigned CSize = 0;
LPARAM WINAPI DLLExport GetPropCreateParam(LPMV mV, LPEDATA edPtr, UINT nPropID)
{
#ifndef RUN_ONLY
	EditData ed (edPtr);
	switch(nPropID)
	{
	case Prop::Files:
		{
			CSize = ed.files.size()+2;
			Combo = new char*[CSize];
			Combo[0] = 0;
			Combo[CSize-1] = 0;
			for(EditData::files_t::size_type i = 0; i < ed.files.size(); ++i)
			{
				Combo[i+1] = new char[ed.files[i].length()+1];
				strcpy(Combo[i+1], ed.files[i].c_str());
			}
			return LPARAM(Combo);
		}
		break;
	}
#endif
	return NULL;
}
void WINAPI DLLExport ReleasePropCreateParam(LPMV mV, LPEDATA edPtr, UINT nPropID, LPARAM lParam)
{
#ifndef RUN_ONLY
	for(unsigned i = 1; i < CSize-1; ++i)
	{
		delete Combo[i];
	}
	delete Combo;
	Combo = 0;
	CSize = 0;
#endif
}

LPVOID WINAPI DLLExport GetPropValue(LPMV mV, LPEDATA edPtr, UINT nPropID)
{
#ifndef RUN_ONLY
	EditData ed (edPtr);
	switch(nPropID)
	{
	case Prop::File:
		return new CPropDataValue(""); //no file is displayed
	case Prop::Files:
		return new CPropDWordValue(DWORD(ed.sel));
	}
#endif
	return NULL;
}
BOOL WINAPI DLLExport GetPropCheck(LPMV mV, LPEDATA edPtr, UINT nPropID)
{
#ifndef RUN_ONLY
	EditData ed (edPtr);
//	switch(nPropID)
//	{
		//
//	}
#endif
	return 0;
}

void WINAPI DLLExport SetPropValue(LPMV mV, LPEDATA edPtr, UINT nPropID, LPVOID lParam)
{
#ifndef RUN_ONLY
	EditData ed (edPtr);
	CPropValue* pValue = (CPropValue*)lParam;

	switch (nPropID)
	{
	case Prop::File:
		{
			LPSTR str = (LPSTR)(((CPropDataValue*)pValue)->m_pData);
			ed.files.push_back(str);
			ed.Serialize(mV, edPtr);
		}
		break;
	case Prop::Files:
		{
			DWORD val = (DWORD)(((CPropDWordValue*)pValue)->m_dwValue);
			ed.sel = EditData::files_t::size_type(val);
		}
		break;
	}
#endif
}
void WINAPI DLLExport SetPropCheck(LPMV mV, LPEDATA edPtr, UINT nPropID, BOOL nCheck)
{
#ifndef RUN_ONLY
	EditData ed (edPtr);
//	switch(nPropID)
//	{
		//
//	}
#endif
}
BOOL WINAPI DLLExport EditProp(LPMV mV, LPEDATA edPtr, UINT nPropID)
{
#ifndef RUN_ONLY
	EditData ed (edPtr);
//	switch(nPropID)
//	{
		//
//	}
#endif
	return FALSE;
}

BOOL WINAPI IsPropEnabled(LPMV mV, LPEDATA edPtr, UINT nPropID)
{
#ifndef RUN_ONLY
	EditData ed (edPtr);
	switch(nPropID)
	{
	case Prop::File:
		return TRUE;
	case Prop::Files:
		return TRUE;
	}
#endif
	return TRUE;
}


int WINAPI DLLExport MakeIconEx(mv _far *mV, cSurface* pIconSf, LPTSTR lpName, fpObjInfo oiPtr, LPEDATA edPtr)
{
#ifndef RUN_ONLY
	pIconSf->Delete();
	pIconSf->Clone(*SDK->Icon);

	pIconSf->SetTransparentColor(RGB(255, 0, 255));
#endif
   return 0;
}

int WINAPI DLLExport CreateObject(mv _far *mV, fpLevObj loPtr, LPEDATA edPtr)
{
#ifndef RUN_ONLY
	if(IS_COMPATIBLE(mV))
	{
		Edif::Init(mV, edPtr);

		EditData().Serialize(mV, edPtr);

		return 0;
	}
#endif
	return -1;
}
void WINAPI	DLLExport CreateFromFile (LPMV mV, LPTSTR fileName, LPEDATA edPtr)
{
#ifndef RUN_ONLY
#endif
}
void WINAPI DLLExport DuplicateObject(mv __far *mV, fpObjInfo oiPtr, LPEDATA edPtr)
{
#ifndef RUN_ONLY
#endif
}
void WINAPI	DLLExport PutObject(mv _far *mV, fpLevObj loPtr, LPEDATA edPtr, ushort cpt)
{
#ifndef RUN_ONLY
	EditData().Serialize(mV, edPtr);
#endif // !defined(RUN_ONLY)
}
void WINAPI	DLLExport RemoveObject(mv _far *mV, fpLevObj loPtr, LPEDATA edPtr, ushort cpt)
{
#ifndef RUN_ONLY
	if(0 == cpt)
	{
		Edif::Free(edPtr);
	}
#endif
}

BOOL WINAPI EditObject (mv _far *mV, fpObjInfo oiPtr, fpLevObj loPtr, LPEDATA edPtr)
{
#ifndef RUN_ONLY
	// Check compatibility
	if ( IS_COMPATIBLE(mV) )
	{
		//
	}
#endif // !defined(RUN_ONLY)
	return FALSE;
}
/*
BOOL WINAPI SetEditSize(LPMV mv, LPEDATA edPtr, int cx, int cy)
{
#ifndef RUN_ONLY
	edPtr->swidth = cx;
	edPtr->sheight = cy;
#endif
	return TRUE;
}
*/

void WINAPI DLLExport GetObjectRect(mv _far *mV, RECT FAR *rc, fpLevObj loPtr, LPEDATA edPtr)
{
#ifndef RUN_ONLY
	rc->right = rc->left + SDK->Icon->GetWidth();
	rc->bottom = rc->top + SDK->Icon->GetHeight();
#endif
	return;
}

void WINAPI DLLExport EditorDisplay(mv _far *mV, fpObjInfo oiPtr, fpLevObj loPtr, LPEDATA edPtr, RECT FAR *rc)
{
#ifndef RUN_ONLY

	LPSURFACE Surface = WinGetSurface((int) mV->mvIdEditWin);

	if(!Surface)
		return;

	SDK->Icon->Blit(*Surface, rc->left, rc->top, BMODE_TRANSP, BOP_COPY, 0);

#endif
}

extern "C" BOOL WINAPI DLLExport IsTransparent(mv _far *mV, fpLevObj loPtr, LPEDATA edPtr, int dx, int dy)
{
#ifndef RUN_ONLY
	//
#endif
	return FALSE;
}

void WINAPI	DLLExport PrepareToWriteObject(mv _far *mV, LPEDATA edPtr, fpObjInfo adoi)
{
#ifndef RUN_ONLY
#endif
}

BOOL WINAPI GetFilters(LPMV mV, LPEDATA edPtr, DWORD dwFlags, LPVOID pReserved)
{
#ifndef RUN_ONLY
#endif
	return FALSE;
}

BOOL WINAPI	DLLExport UsesFile (LPMV mV, LPTSTR fileName)
{
#ifndef RUN_ONLY
#endif
	return FALSE;
}


DWORD WINAPI DLLExport GetTextCaps(mv _far *mV, LPEDATA edPtr){ return 0; }
BOOL WINAPI DLLExport GetTextFont(mv _far *mV, LPEDATA edPtr, LPLOGFONT plf, LPTSTR pStyle, UINT cbSize){ return TRUE; }
BOOL WINAPI DLLExport SetTextFont(mv _far *mV, LPEDATA edPtr, LPLOGFONT plf, LPCSTR pStyle){ return TRUE; }
COLORREF WINAPI DLLExport GetTextClr(mv _far *mV, LPEDATA edPtr){ return 0; }
void WINAPI DLLExport SetTextClr(mv _far *mV, LPEDATA edPtr, COLORREF color){}
DWORD WINAPI DLLExport GetTextAlignment(mv _far *mV, LPEDATA edPtr){ return 0; }
void WINAPI DLLExport SetTextAlignment(mv _far *mV, LPEDATA edPtr, DWORD dwAlignFlags){}


void WINAPI InitParameter(mv _far *mV, short code, paramExt* pExt)
{
#ifndef RUN_ONLY
	//
#endif
}
/*
#ifndef RUN_ONLY
BOOL CALLBACK DLLExport SetupProc(HWND hDlg, UINT msgType, WPARAM wParam, LPARAM lParam)
{
	paramExt*			pExt;

	switch (msgType)
	{
		case WM_INITDIALOG: // Init dialog

			// Save edptr
			SetWindowLong(hDlg, DWL_USER, lParam);
			pExt=(paramExt*)lParam;

			SetDlgItemText(hDlg, IDC_EDIT, pExt->pextData);
			return TRUE;

		case WM_COMMAND: // Command

			// Retrieve edptr
			pExt = (paramExt *)GetWindowLong(hDlg, DWL_USER);

			switch (wmCommandID)
			{
			case IDOK:	// Exit
				GetDlgItemText(hDlg, IDC_EDIT, pExt->pextData, 500);
				pExt->pextSize=sizeof(paramExt)+strlen(pExt->pextData)+1;
				EndDialog(hDlg, TRUE);
				return TRUE;

				default:
					break;
			}
			break;

		default:
			break;
	}
	return FALSE;
}
#endif // !defined(RUN_ONLY)
*/void WINAPI EditParameter(mv _far *mV, short code, paramExt* pExt)
{
#ifndef RUN_ONLY
	//DialogBoxParam(hInstLib, MAKEINTRESOURCE(DB_TRYPARAM), mV->mvHEditWin, SetupProc, (LPARAM)(LPBYTE)pExt);
#endif
}

void WINAPI GetParameterString(mv _far *mV, short code, paramExt* pExt, LPSTR pDest, short size)
{
#if !defined(RUN_ONLY)
	//
#endif
}
